{
  "factory": {
    "id": "jaas-realm",
    "type": "entaxy.security.jaas.realm",
    "description": "Factory jaas-realm of entaxy.security.jaas.realm",
    "parent": "abstract-jaas-component",
    "isAbstract": false
  },
  "entaxy.security.jaas.realm": {},
  "fields": {
    "objectId": {
      "displayName": "Realm name"
    },
    "rank": {
      "displayName": "Rank",
      "description": "Specifies an optional rank for resolving naming conflicts between JAAS realms . When two or more JAAS realms are registered under the same name, the OSGi container always picks the realm instance with the highest rank. If you decide to override the default realm, karaf, you should specify a rank of 100 or more, so that it overrides all of the previously installed karaf realms. For more details see <a target=\"_blank\" href=\"https://docs.entaxy.ru/entaxy-core/${project.version}/core/security/security-jaas.html\">Entaxy docs</a> and <a target=\"_blank\" href=\"https://karaf.apache.org/manual/latest/security\">Karaf docs</a>",
      "type": "number",
      "required": true,
      "defaultValue": -1
    },
    "modules": {
      "type": "list",
      "group": "modules",
      "@TYPEINFO": {
        "excludeLabel": true,
        "enablePrivateObjectCreation": true,
        "privateObjectTypes": [{
          "name": "entaxy.security.jaas.loginmodule",
          "displayName": "Login Module"
        }],
        "itemTitle": {
          "fields": ["factoryId", "classifier"],
          "delimiter": "."
        },
        "validation": {
          "rules": {
            "checkUniqueness": {
              "fields": ["classifier"]
            }
          }
        }
      }
    }
  },
  "outputs": {
    "init": {
      "isDefault": true,
      "fields": {
        "rank": {},
        "modules": {}
      },
      "config": {
        "configurable": false
      }
    }
  }
}
